;-----------------------
;   0
SelectSide0:
	sbi PORTB, CS1
	cbi PORTB, CS2
 ret
;-----------------------
;   1
SelectSide1:
	cbi PORTB, CS1
	sbi PORTB, CS2
 ret
;--------------------------------
;      
IntitLCD:
	ldi temp3, 0x02	;  2      
	
InitNextChip:
	cpi temp3,0x02
	brne NotSide0	 
	rcall SelectSide0		;     0
	rjmp EndSelectChip
	
NotSide0:

	cpi temp3,0x01
	brne EndInitLCD	 
	rcall SelectSide1	;     1

EndSelectChip:
     
    CommandString STR_InitLCD		;   
	
	clr PageAdress
	ldi temp, PageLehgth
	mov ByteCounter, temp
	
FillPage:
	clr Parametr0
	rcall WriteData
	dec ByteCounter
	brne FillPage
wdr	
	cpi PageAdress, MaxPage-1		;  ?
	breq EndFillPage
	rcall NextString
	ldi temp, PageLehgth
	mov ByteCounter, temp
	rjmp FillPage
	
EndFillPage:
	dec temp3
	brne InitNextChip
	
EndInitLCD:
;     
	rcall SelectSide0
	rcall Home
ret 
;------------------------------ 
WaitReady:
	in temp, PORTB	;    DI  RW
	push temp		

	clr temp
	out DDRA, TEMP
	cbi PORTB, DI
	sbi PORTB, RW
NextWaitReady:	
	nop
	sbi PORTB, E
	nop
	nop
	nop
	in temp, PINA
	cbi PORTB, E
	nop
	nop
	rol temp
    brcs NextWaitReady
	pop temp
	out PORTB, temp ;    DI  RW
 ret
;--------------------------
WriteByte:
	rcall WaitReady
	ldi temp, 0xFF
	out DDRA, TEMP
	cbi PORTB, RW
	out PORTA, Parametr0
	nop
	sbi PORTB, E
	nop
	nop
	cbi PORTB, E
	nop
 ret
;--------------------------
;      
;    Parametr0 
WriteCommand:
	cbi PORTB, DI
	rcall WriteByte	
	ret
;--------------------------
;       
;    Parametr0
WriteData:
	sbi PORTB, DI
	rcall WriteByte	 
	ret
;---------------------------- 
;       .    0x99
;     CommandString/DataString
;    ldi R30, low(@0*2)
;    ldi R31, High(@0*2) 
;    cbi/sbi PORTB, DI		/
;    rcall SendArrayData 
SendArrayData:
	lpm Parametr0, Z
	cpi Parametr0, 0x99
	breq EndSendArrayData
	rcall WriteByte
	adiw R30,1
	rjmp SendArrayData	
EndSendArrayData:
	ret
;-----------------------------
;       (  ) 
;   PageAdress 0xFF -     
Home:
	ldi PageAdress, 0xFF
NextString:
	inc PageAdress
	mov Parametr0, PageAdress	;  
	ori Parametr0, S_Page			;   
	 rcall WriteCommand
	ldi Parametr0, Y_ADRESS		;     
	 rcall WriteCommand
	ret
;-----------------------------------
;     
;  
; Parametr0 -   0  9
DisplayDigit:
    ldi R30, low(Digit*2)	;    
    ldi R31, High(Digit*2) 
    
;   6 -  
    lsl Parametr0			
    mov temp, Parametr0		; x2
    lsl Parametr0			; x4
    add Parametr0,temp		; x2 + x4 = x6
    add R30, Parametr0		;      
    clr Parametr0
    adc R31,Parametr0

DisplayChar:		;        
					;  Z        
    
	ldi temp,6		; 5  ,  
CykDisplayDigit:
	push temp
	lpm Parametr0, Z
	rcall WriteData
	adiw R30,1
	pop temp		
	dec temp
	brne CykDisplayDigit
    ret
    
Digit:			
Char30: .db 0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00	 ; '0'
Char31: .db 0x00, 0x42, 0x7F, 0x40, 0x00, 0x00	 ; '1'
Char32: .db 0x42, 0x61, 0x51, 0x49, 0x46, 0x00	 ; '2'
Char33: .db 0x22, 0x41, 0x49, 0x49, 0x36, 0x00	 ; '3'
Char34: .db 0x18, 0x14, 0x12, 0x7F, 0x10, 0x00	 ; '4'
Char35: .db 0x27, 0x45, 0x45, 0x45, 0x39, 0x00	 ; '5'
Char36: .db 0x3C, 0x4A, 0x49, 0x49, 0x30, 0x00	 ; '6'
Char37: .db 0x01, 0x71, 0x09, 0x05, 0x03, 0x00	 ; '7'
Char38: .db 0x36, 0x49, 0x49, 0x49, 0x36, 0x00	 ; '8'
Char39: .db 0x06, 0x49, 0x49, 0x49, 0x3E, 0x00	 ; '9'
;-----------------------------------------------------
;      UART ASCII .
TableCHAR:	 .db "0123456789ABCDEF"
STR_InitLCD: .db 0xC0, 0x40, 0xB8, 0x3F, 0x99, 0x99

;TR_Chanel:	.db 0x7F, 0x08, 0x14, 0x22, 0x41, 0x00	 ; ''
;			.db 0x7E, 0x11, 0x11, 0x11, 0x7F, 0x00	 ; ''
;			.db 0x7F, 0x08, 0x08, 0x08, 0x7F, 0x00	 ; ''
;			.db 0x7E, 0x11, 0x11, 0x11, 0x7F, 0x00	 ; ''
;			.db 0x40, 0x3E, 0x01, 0x01, 0x7F, 0x00	 ; ''
;			.db 0x99, 0x99
			
;		.db 0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00	 ; '0'
;		.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	 ; ' '
;		.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	 ; ' '
;		.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	 ; ' '
;		.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	 ; ' '
;		.db 0x00, 0x00, 0x00, 0x00									
		
;CharC0: .db 0x7E, 0x11, 0x11, 0x11, 0x7F, 0x00	 ; ''
;CharC1: .db 0x7F, 0x49, 0x49, 0x49, 0x79, 0x00  ; ''
;CharC2: .db 0x7F, 0x49, 0x49, 0x49, 0x36, 0x00  ; ''
;CharC3: .db 0x7F, 0x01, 0x01, 0x01, 0x01, 0x00  ; ''
;CharC4: .db 0x60, 0x3E, 0x21, 0x21, 0x7F, 0x00  ; ''
;CharC5: .db 0x7F, 0x49, 0x49, 0x49, 0x41, 0x00  ; ''
;CharC6: .db 0x73, 0x0C, 0x7F, 0x0C, 0x73, 0x00	 ; ''
;CharC7: .db 0x22, 0x41, 0x49, 0x49, 0x36, 0x00	 ; ''
;CharC8: .db 0x7F, 0x20, 0x10, 0x08, 0x7F, 0x00	 ; ''
;CharC9: .db 0x7F, 0x20, 0x11, 0x08, 0x7F, 0x00	 ; ''
;CharCA: .db 0x7F, 0x08, 0x14, 0x22, 0x41, 0x00	 ; ''
;CharCB: .db 0x40, 0x3E, 0x01, 0x01, 0x7F, 0x00	 ; ''
;CharCC: .db 0x7F, 0x02, 0x04, 0x02, 0x7F, 0x00	 ; ''
;CharCD: .db 0x7F, 0x08, 0x08, 0x08, 0x7F, 0x00	 ; ''
;CharCE: .db 0x3E, 0x41, 0x41, 0x41, 0x3E, 0x00	 ; ''
;CharCF: .db 0x7F, 0x01, 0x01, 0x01, 0x7F, 0x00	 ; ''
;CharD0: .db 0x7F, 0x09, 0x09, 0x09, 0x06, 0x00	 ; ''
;CharD1: .db 0x3E, 0x41, 0x41, 0x41, 0x22, 0x00	 ; ''
;CharD2: .db 0x01, 0x01, 0x7F, 0x01, 0x01, 0x00	 ; ''
;Char93: .db 0x07, 0x48, 0x48, 0x48, 0x3F, 0x00	 ; ''
;CharD4: .db 0x0E, 0x11, 0x7F, 0x11, 0x0E, 0x00	 ; ''
;CharD5: .db 0x63, 0x14, 0x08, 0x14, 0x63, 0x00	 ; ''
;CharD6: .db 0x7F, 0x40, 0x40, 0x7F, 0x40, 0x00	 ; ''
;CharD7: .db 0x0F, 0x10, 0x10, 0x10, 0x7F, 0x00	 ; ''
;CharD8: .db 0x7F, 0x40, 0x7E, 0x40, 0x7F, 0x00	 ; ''
;CharD9: .db 0x3F, 0x20, 0x3E, 0x20, 0x7F, 0x00	 ; ''
;CharDA: .db 0x01, 0x7F, 0x44, 0x44, 0x38, 0x00	 ; ''
;CharDB: .db 0x7F, 0x44, 0x44, 0x38, 0x7F, 0x00	 ; ''
;CharDC: .db 0x7F, 0x44, 0x44, 0x44, 0x38, 0x00	 ; ''
;CharDD: .db 0x22, 0x41, 0x49, 0x49, 0x3E, 0x00	 ; ''
;CharDE: .db 0x7F, 0x08, 0x7F, 0x41, 0x7F, 0x00	 ; ''
;CharDF: .db 0x4E, 0x31, 0x11, 0x11, 0x7F, 0x00	 ; ''
;Char2B: .db 0x08, 0x08, 0x3E, 0x08, 0x08, 0x00	 ; '+'

Char2D: .db 0x08, 0x08, 0x08, 0x08, 0x00, 0x00	 ; '-'

;Char3A: .db 0x00, 0x36, 0x36, 0x00, 0x00, 0x00	 ; ':'

;.db 0x99, 0x99

STR_Wrapped:
		.db 0x3E, 0x41, 0x41, 0x41, 0x3E, 0x00	; ''
		.db 0x7F, 0x49, 0x49, 0x49, 0x79, 0x00  ; ''
		.db 0x7F, 0x09, 0x09, 0x09, 0x06, 0x00	; ''
		.db 0x7F, 0x44, 0x44, 0x38, 0x7F, 0x00	; ''
		.db 0x7F, 0x49, 0x49, 0x49, 0x36, 0x00  ; ''		
		.db 0x99, 0x99		
Space:
		.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x99	; ' '
		