;  thermometr.asm
.nolist
.INCLUDE "tn26def.inc"
.list

;  
;  A   LCD
;  B 

.equ DI = PB0 	; ==1 , ==0 
.equ TxD_CS2 = PB1 	; / COM,   CS2 

.equ CS1 = PB3	 

.equ RW = PB5 	; /
.equ E = PB6 	;  /


; LCD Registers   
; LCD     Hitachi HD61202U
.equ LCD_Page		= 0xB8	;  . 0..7  B8..BF
.equ Y_ADRESS	= 0x40		;   0..63  40..4F
.equ	PageLehgth	=	64	;  ()  
.equ	MaxPage		=	8	;  

;   
;.equ START_LINE	= 0xC0	;    .
;.equ DISPLAY_ON	= 0x3F	; Turn display on
;.equ DISPLAY_OFF= 0x3E	; Turn display off


;---------  

; R0, R1  DELAY100ms

.def ByteCounter		= r5
.def ByteToDisplay		= r6

.def temp  				= r16
.def temp2 				= r17
.def temp3				= r18 

.def Parametr0 			=R19

;    BIN- BCD

.def    tBCD0   =r20    ; BCD value digits 0 and 1
.def    tBCD1   =r21    ; BCD value digits 2 and 3
.def    tBCD2   =r22    ; BCD value digit 4 (MSD is lowermost nibble)

.def    Chanel  =r24    ;   
.def 	PageAdress= r25

; R28, R29     1,   
; R30, R31    

;    

.equ	LowerTemp	=	40	; - 40    (termtable.inc)
.equ	HighTemp	=	110 + 40; + 110    (termtable.inc)

.include "macro.inc"


;.DSEG	;data segment (internal RAM)
;   
;	Temp0: .byte 2			
;	Temp1: .byte 2
;	Temp2: .byte 2
;	Temp3: .byte 2
;	Temp4: .byte 2
;	Temp5: .byte 2
;	Temp6: .byte 2
;	Temp7: .byte 2
	
.CSEG             ;  
.ORG $0

rjmp SYSRES       ;  .  

reti ; INT0addr	=$001	;External Interrupt0 Vector Address
reti ; IOPINSaddr	=$002	;Pin change interrupt
reti ; OC1Aaddr	=$003	;Output Compare1A Interrupt Vector Address
reti ; OC1Baddr	=$004	;Output Compare1B Interrupt Vector Address
reti ; OVF1_ISR ;	=$005	;Overflow1 Interrupt Vector Address
rjmp  OVF0_ISR	; =$006	;Overflow0 Interrupt Vector Address
reti ;.equ	USI_STARTaddr	=$007	;Universal Seria Bus Start Interrupt Address
reti ;.equ	USI_OVFaddr	=$008	;Universal Seria Bus Overflow Interrupt Address
reti ;.equ	ERDYaddr	=$009	;EEPROM Ready Interrupt Vector Address
reti ;.equ	ACIaddr 	=$00A	;Analog Comparator Interrupt Vector Address
reti ;.equ	ADCCaddr 	=$00B	;ADC conversion complete Interrupt Vector Address


SYSRES:  ;  
	cli   
	ldi temp,0x0f
	out WDTCR,temp   	;WahsinDOG on 2sec,   2.
	wdr

	ldi temp,0x00		;   AVreal      
	cpi temp,0x00
	breq NotOSCCAL
	out OSCCAL, temp
NotOSCCAL:	
	ldi temp, RAMEND
	out SP, TEMP
	
	sbi ACSR,7          ;Comparator Disable, . (  )
    DisableTimer0

	ldi temp,0xff       ;  ,   .
	out TIFR,temp
	out GIFR,temp
	
	ldi temp, (1<<SE)+(1<<SM0)	;     
	out MCUCR, temp

	ldi temp,5          	; 0 = 1024 ( 1/7 sec)
	out TCCR0,temp

;      ,   4 000 000 /32 = 125 000
	ldi temp, (1<<ADEN)+(1<<ADIE)+(1<<ADIF)+(1<<ADPS2)+(1<<ADPS0)
	out ADCSR,temp
	
	ldi temp,0xFF
	 out PORTA,temp
	ldi temp,0x00
	 out DDRA,temp

	ldi temp,0xBF	; E==0
	out PORTB,temp

	ldi temp, (1<<DI)+(1<<TxD_CS2)+(1<<RW)+(1<<CS1)+(1<<E)
	out DDRB,temp

	rcall WaitReady
	rcall IntitLCD
;   ""     .
;    
	ldi temp, 0xAA
	mov ByteToDisplay, temp
	ldi YL, PageLehgth	
	ldi YH, 0
	rcall SelectSide1
	rcall Home

;        
;   
	EnableTimer0
	sei
;   ,    	
qqq:
rjmp qqq
;-----------------------------------------------------------
OVF0_ISR:
	DisableTimer0
    wdr
  
	rcall SelectSide0		;     0- 
	rcall Home				
	
SLEEP_OK:
	
	sbi ADCSR,ADIF     		;  		
	ldi Chanel, 0x00 		;ADC: Vref==Vcc
	out ADMUX,Chanel
	
CykleMeasure:

	wdr	

	clr temp			;  0..6   
	out DDRA, temp
	out PORTA, temp
	
	cbi DDRB, PB4		;  7   
	cbi PORTB, PB4
	
	Delay100mS

	sei
	sbi ADCSR, ADSC     ;START ADC
	sleep
	cli	
;  ,    	
    in temp, ADCL
	in temp2, ADCH
	
	rcall ADCtoT

	cpi Parametr0, 0		;   
	breq Wrapped

	cpi Parametr0, LowerTemp+HighTemp	;      
	brcs NotWrapped
	
Wrapped:	
	DataString STR_Wrapped		;   ''
	rjmp NextChanel
	
NotWrapped:
	cpi parametr0, LowerTemp		;      ?
	brge BiggerZero
;	,   LowerTemp      
	ldi temp, LowerTemp
	sub temp, Parametr0
	push temp	;   

	ldi R30, low(Char2D*2)	;    
    ldi R31, High(Char2D*2) 	
	rcall DisplayChar		;  
	pop temp	;  	
	rjmp ConvertToBCD

BiggerZero:	
	subi parametr0, LowerTemp
	mov temp, parametr0
	
;   - 	
ConvertToBCD:	
	clr temp2
    rcall Bin2BCD16
;  3  
	mov Parametr0, tBCD1
	andi Parametr0, 0x0F
	rcall DisplayDigit
	
	mov Parametr0, tBCD0
	swap Parametr0
	andi Parametr0, 0x0F
	rcall DisplayDigit

	mov Parametr0, tBCD0
	andi Parametr0, 0x0F
	rcall DisplayDigit
	DataString Space		;    
	DataString Space		;    
	DataString Space		;    
	DataString Space		;    
	
NextChanel:
	inc Chanel
	cpi Chanel, 0x08		;  
	breq AllChanelMeasured

	out ADMUX, Chanel
	rcall NextString		;    
	rjmp CykleMeasure
	
AllChanelMeasured:	
;   

	rcall SelectSide1
	mov Parametr0, ByteToDisplay
	rcall WriteData

	dec YL
	brne qq
	
;   

	ldi YL, PageLehgth	;   
	mov PageAdress, YH
	rcall NextString
	mov YH, PageAdress
	cpi YH, MaxPage
	brne qq 
	ldi YH, 0
	ldi temp, 0xFF
	eor ByteToDisplay, temp		;   
	rcall Home
qq:	
	EnableTimer0
reti
;-----------------------------------------------------------
.include "procedure.inc"	; ,  UART  ..
.include "LCD_proc.inc"		;   LCD
.include "termtable.inc"	;   ,      
